/***************************************************************************
 *   Copyright (C) 2007 by apterium   *
 *   apterium@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __CAESAR_ANALYSIS_H
#define __CAESAR_ANALYSIS_H

//TODO : what to set here ?
//#include "ui_CaesarAnalysis.h"
#include "Text.h"

class mainWindow;

/**
 * @short User interface for Caesar ciphertext cryptanalysis.
 * 
 * This class should provide direct computations and histograms plot of
 * frequency analysis of the text.
 * @todo how to draw histograms in a new window ?
 * @author apterium 
 */
class CaesarAnalysis /*: 
		       public QWidget,
		       public Ui::CaesarAnalysis */
{
	//	Q_OBJECT
public:
	/**
	 * Creates a new CaesarAnalysis instance.
	 * 
	 * @param *main the main window of CrypTooLinux.
	 * @param text the text to cryptanalyse.
	 * @param title the title of the window.
	 */
	CaesarAnalysis(mainWindow *main, QString text, QString title);
	
	
	//private slots:
	/**
	 *
	 *
	 */
	
	
private:
	/**
	 * Makes the connections between signals of the UI and the slot functions.
	 * 
	 */
	void createConnections();
	
	/**
	 * Computes the frequencies and print them in a new window.
	 * 
	 */
	void computeFrequencies();
	
	/**
	 * The text we work on.
	 * 
	 */
	QString workText;
	
	/**
	 * The title of the window of CrypTooLinux main Window which contains
	 * the text to cryptanalyse.
	 * 
	 */
	QString workTitle;
	
	/**
	 * The case sensitivity of the text.
	 * 
	 */
	Qt::CaseSensitivity cs;
	
	/**
	 * CrypTooLinux main window, where we draw back the histograms.
	 * 
	 */
	mainWindow *mw;

};

#endif //__CAESAR_ANALYSIS_H
