/***************************************************************************
 *   Copyright (C) 2007 by Andrea Moro   *
 *   andrea_moro@email.it   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef ANALYSISOPT_H
#define ANALYSISOPT_H

#include "ui_analysis_opt.h"

class mainWindow;

/** 
 * @short User interface for Analysis Options.
 *
 * Window to edit options related to cryptoanalysis.
 */
class analysisOpt :
		public QWidget,
  public Ui::analysisOpt
{
	Q_OBJECT
public:
	/**
	 * Creates a new analysisOpt instance.
	 *
	 * @param *main the main window of CrypTooLinux
	 */
	analysisOpt(mainWindow *main);
private slots:
	/**
	 * Save the options in the struct of the options in the main window.
	 */
	void apply();
private:
	/**
	 * CrypTooLinux main window.
	 */
	mainWindow *mw;
};
#endif
