/***************************************************************************
 *   Copyright (C) 2007 by Andrea Moro   *
 *   andrea_moro@email.it   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/
#include <QtGui>
#include "drawParam.h"
#include "mainWindow.h"

drawParam::drawParam(mainWindow *main)
{
	setupUi(this);
	connect(applyButton,SIGNAL(clicked()),this,SLOT(apply()));
	mw=main;
	char tmp[10];
	sprintf(tmp,"%d",mw->options.plot_opt.bar_width);
	bar_width->setText(tmp);
	sprintf(tmp,"%d",mw->options.plot_opt.curve_width);
	curve_width->setText(tmp);
	zero->setCheckState(mw->options.plot_opt.zero?(Qt::Checked):(Qt::Unchecked));
	autocorr_relative->setCheckState(mw->options.plot_opt.autocorr_relative?(Qt::Checked):(Qt::Unchecked));
}

void drawParam::apply()
{
	int tmp1,tmp2;
	tmp1=atoi(bar_width->text().toAscii().data());
	tmp2=atoi(curve_width->text().toAscii().data());
	if((tmp1<1)||(tmp1>10)||(tmp2<1)||(tmp2>10))
	{
		QMessageBox::warning(this, tr("Warning"),
				     tr("The width can be only in 1-10!"));
		return;
	}
	mw->options.plot_opt.bar_width=atoi(bar_width->text().toAscii().data());
	mw->options.plot_opt.curve_width=atoi(curve_width->text().toAscii().data());
	mw->options.plot_opt.zero=zero->checkState()==Qt::Checked?true:false;
	mw->options.plot_opt.autocorr_relative=autocorr_relative->checkState()==Qt::Checked?true:false;
	close();
}

#include "drawParam.moc"
