/***************************************************************************
 *   Copyright (C) 2007 by Andrea Moro   *
 *   andrea_moro@email.it   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/
#include <QtGui>
#include "furtOpt.h"
#include "mainWindow.h"

furtOpt::furtOpt(mainWindow *main)
{
	setupUi(this);
	connect(applyButton,SIGNAL(clicked()),this,SLOT(apply()));
	mw=main;
	intro->setCheckState(mw->options.further_opt.intro?(Qt::Checked):(Qt::Unchecked));
	aliceName->setText(mw->options.further_opt.alice_name);
}

void furtOpt::apply()
{
	if(aliceName->text().length()==0)
	{
		QMessageBox::warning(this, tr("Warning"),
			tr("The name cannot be empty!"));
		return;
	}
	mw->options.further_opt.alice_name=aliceName->text();
	mw->options.further_opt.intro=intro->checkState()==Qt::Checked?true:false;
	close();
}

#include "furtOpt.moc"
