/***************************************************************************
 *   Copyright (C) 2007 by apterium   *
 *   apterium@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __LIB_CLASSICAL_ANALYSIS_TEST_H
#define __LIB_CLASSICAL_ANALYSIS_TEST_H

#include <vector>
#include "libClassicalAnalysis.h"

using namespace libClassicalAnalysis;

/**
 * Runs all tests on the implementation of the libClassicalAnalysis.
 * 
 * @author apterium
 * @return the error code of the failed test, if any, or 0 if all tests passed.
 */
int main(int argc, char** argv);

/**
 * Computes the frequencies of the letters of the given alphabet in the given
 * text.
 * 
 * @param text a constant reference to the text.
 * @param alphabet the letters the program shall take into account.
 */
int testFrequencies(const std::vector<mpz_class>& text, const std::vector<mpz_class>& alphabet);

/**
 * Initialises a text and an alphabet.
 * 
 */
void initialiseText(std::vector<mpz_class>& text, std::vector<mpz_class>& alphabet);

#endif //__LIB_CLASSICAL_ANALYSIS_TEST_H
