/***************************************************************************
 *   Copyright (C) 2007 by apterium   *
 *   apterium@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __LIB_NUMBER_THEORY_TEST_H
#define __LIB_NUMBER_THEORY_TEST_H

#include "libNumberTheory.h"

using namespace libNumberTheory;

/**
 * Runs all tests on the implementation of the libNumberTheory.
 * 
 * @author apterium
 * @return the error code of the failed test, if any, or 0 if all tests passed.
 */
int main(int argc, char** argv);

/**
 * Tests the bruteforce compositeness test.
 * 
 * @param n the number to test.
 */
int testBruteforceCompositenessTest(const mpz_class& n);

/**
 * Tests the GMP compositeness test.
 * 
 * @param n the number to test.
 */
int testGMPCompositenessTest(const mpz_class& n);

/**
 * Tests the Eratosthene sieve.
 * 
 * @param n the number to test.
 */
int testEratostheneSieve(const mpz_class& n);


#endif //__LIB_NUMBER_THEORY_TEST_H
