/***************************************************************************
 *   Copyright (C) 2007 by apterium   *
 *   apterium@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __LIB_ALGEBRA_RING_Z_H
#define __LIB_ALGEBRA_RING_Z_H

#include <gmpxx.h>
#include "Ring.h"

namespace libalgebra
{
	/**
	 * @short Implemtation of the ring Z of the integers. 
	 * Needed by some implementations of algorithms which needs to know
	 * whether the rign is Euclidean or not.
	 *
	 * @author apterium.
	 */
	class RingZ : public Ring
	{
	public:
		/**
		 * Constructs a new instance of the ring of the integers.
		 *
		 */
		RingZ()
		{
		};
		
		/**
		 * Destructor
		 * 
		 */
		~RingZ()
		{
		};

		/**
		 * @see Field
		 * 
		 */
		inline mpz_class characteristic() const
		{
			return mpz_class(0);
		};

		/**
		 * @see Field
		 * 
		 */
		inline mpz_class cardinality() const
		{
			return mpz_class(0);
		};
		
		/**
		 * @see Ring
		 * 
		 */
		inline bool isIntegralDomain() const
		{
			return true;
		};
		
		inline bool isEuclidean() const
		{
			return true;
		};
	};
}

#endif //__LIB_ALGEBRA_RING_Z_H
